<?php
/**
 * @version		3.7
 * @package		Joomla
 * @subpackage	Joom Donation
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2014 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die ;
class DonationViewDonationHtml extends OSFViewHtml
{
    function display()
    {
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $nullDate = $db->getNullDate();
        $user = JFactory::getUser();
        $config = DonationHelper::getConfig();
        $userId = $user->get('id');
        $campaignId = $this->input->getInt('campaign_id', 0);
        $rowFields = DonationHelper::getFormFields();
        $input = $this->input;
        $captchaInvalid = $input->getInt('captcha_invalid', 0);
        if ($captchaInvalid)
        {
            $data = $input->post->getData();
        }
        else
        {
            //Keep the data
            $app = JFactory::getApplication();
            $data = $app->getUserState('com_jdonation.formdata', null);
            if ($data)
            {
                $data = unserialize($data);
            }
            else
            {
                $data = DonationHelper::getFormData($rowFields, $userId, $config);
            }
        }
        if ($userId && !isset($data['first_name']))
        {
            //Load the name from Joomla default name
            $name = $user->name;
            if ($name)
            {
                $pos = strpos($name, ' ');
                if ($pos !== false)
                {
                    $data['first_name'] = substr($name, 0, $pos);
                    $data['last_name'] = substr($name, $pos + 1);
                }
                else
                {
                    $data['first_name'] = $name;
                    $data['last_name'] = '';
                }
            }
        }
        if ($userId && !isset($data['email']))
        {
            $data['email'] = $user->email;
        }
        if (!isset($data['country']) || !$data['country'])
        {
            $data['country'] = $config->default_country;
        }
        //Get data
        $form = new OSFForm($rowFields);
        if ($captchaInvalid)
        {
            $useDefault = false;
        }
        else
        {
            $useDefault = true;
        }
        $form->bind($data, $useDefault);
        $form->prepareFormField($this->input->getInt('campaign_id', 0));
        if ($campaignId > 0)
        {
            $query->clear();
            $query->select('*')
                ->from('#__jd_campaigns')
                ->where('id='.$campaignId);
            $db->setQuery($query);
            $campaign = $db->loadObject();
            $this->campaign = $campaign;
        }
        $paymentMethod = $input->getString('payment_method', os_payments::getDefautPaymentMethod());
        $amount = $input->getFloat('amount', 0);
        if ($amount == 0)
        {
            $amount = '';
        }
        $rdAmount = $input->getFloat('rd_amount', 0);

	    if ($campaignId > 0)
	    {
			if ($campaign->donation_type == 1)
			{
				$donationType = 'onetime';
			}
		    elseif($campaign->donation_type == 2)
		    {
			    $donationType = 'recurring';
		    }
		    else
		    {
			    $donationType = $input->get('donation_type', 'onetime', 'string');
		    }
	    }
	    else
	    {
		    $donationType = $input->get('donation_type', 'onetime', 'string');
	    }
        //Campaigns selection dropdown
        $options = array() ;
        $options[] = JHtml::_('select.option', 0 , JText::_('JD_SELECT_CAMPAIGN') , 'id', 'title') ;
        $query->clear();
        $query->select('*')
            ->from('#__jd_campaigns')
            ->where('published = 1')
            //->where('(start_date = '.$db->quote($nullDate).' OR DATE(start_date) <= CURDATE())')
            //->where('(end_date = '.$db->quote($nullDate).' OR DATE(end_date) >= CURDATE())')
            ->order('ordering, title');
        $db->setQuery($query);
        $rowCampaigns = $db->loadObjectList();
        $options = array_merge($options, $rowCampaigns) ;
        $lists['campaign_id'] = JHtml::_('select.genericlist', $options, 'campaign_id', ' class="input-large" onchange="processChangeCampaign();" ', 'id', 'title', $campaignId) ;
        if ($config->enable_recurring)
        {
            $options = array();
            /*$options[] = JHtml::_('select.option', '',JText::_('JD_SELECT')) ;*/
            if (empty($config->recurring_frequencies))
            {
                $config->recurring_frequencies = 'd,w,m,q,s,a';
            }
            $recurringFrequencies = explode(',', $config->recurring_frequencies);
            if (in_array('d', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'd',JText::_('JD_DAILY'));
            }
            if (in_array('w', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'w',JText::_('JD_WEEKLY'));
            }
            if (in_array('b', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'b',JText::_('JD_BI_WEEKLY'));
            }
            if (in_array('m', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'm',JText::_('JD_MONTHLY'));
            }
            if (in_array('q', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'q',JText::_('JD_QUARTERLY'));
            }
            if (in_array('s', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 's',JText::_('JD_SEMI_ANNUALLY'));
            }
            if (in_array('a', $recurringFrequencies))
            {
                $options[] = JHtml::_('select.option', 'a',JText::_('JD_ANNUALLY'));
            }
            $lists['r_frequency'] = JHtml::_('select.genericlist', $options, 'r_frequency', ' class="input-medium" ', 'value', 'text', $input->get('r_frequency', '')) ;
        }
        $options = array();
        $options[] = JHtml::_('select.option', 'onetime', JText::_('JD_ONETIME')) ;
        $options[] = JHtml::_('select.option', 'recurring', JText::_('JD_RECURRING')) ;
        $lists['donation_type'] = JHtml::_('select.radiolist', $options, 'donation_type', ' onclick="changeDonationType();" ', 'value', 'text', $donationType);
        if ($config->amount_by_campaign)
        {
            //For campaigns which doesn't have it own pre-defined amount and pre-defined amount explanation, we just use data from Configuration
            for ($i = 0 , $n = count($rowCampaigns) ; $i < $n ; $i++)
            {
                $rowCampaign = $rowCampaigns[$i] ;
                if (!$rowCampaign->amounts)
                {
                    $rowCampaign->amounts = $config->donation_amounts;
                }
                if (!$rowCampaign->amounts_explanation)
                {
                    $rowCampaign->amounts_explanation = $config->donation_amounts_explanation;
                }
            }

            if ($campaignId > 0)
            {
                $config->donation_amounts = $campaign->amounts ;
                $config->donation_amounts_explanation = $campaign->amounts_explanation ;
            }
        }
        $options =  array() ;
        $options[] = JHtml::_('select.option', 'Visa', 'Visa') ;
        $options[] = JHtml::_('select.option', 'MasterCard', 'MasterCard') ;
        $options[] = JHtml::_('select.option', 'Discover', 'Discover') ;
        $options[] = JHtml::_('select.option', 'Amex', 'American Express') ;
        $lists['card_type'] = JHtml::_('select.genericlist', $options, 'card_type', ' class="inputbox" ', 'value', 'text') ;
        //Expiration month, expiration year
        $lists['exp_month'] = JHtml::_('select.integerlist', 1, 12, 1, 'exp_month', ' class="input-small" ', $input->getInt('exp_month', date('m')), '%02d') ;
        $currentYear = date('Y');
        $lists['exp_year'] = JHtml::_('select.integerlist', $currentYear, $currentYear + 10, 1, 'exp_year', 'class="input-small"', $input->getInt('exp_year', date('Y')));
        //Support disable recurring for each campaign
        $recurringString = "var recurrings = new Array();\n";
        for ($i = 0 , $n = count($rowCampaigns) ; $i < $n ; $i++)
        {
            $row = $rowCampaigns[$i] ;
            $recurringString.= " recurrings[$row->id] = ".(int)$row->donation_type.";\n" ;
        }

        //Allow donors to choose to pay for payment gateway fee
        if ($config->pay_payment_gateway_fee)
        {
            $lists['pay_payment_gateway_fee'] = JHtml::_('select.booleanlist', 'pay_payment_gateway_fee', ' class="inputbox" ', $input->getInt('pay_payment_gateway_fee', 0)) ;
        }
        //Allow users choose to pay for paypal currencies
        if ($config->currency_selection)
        {
            if ($config->active_currencies)
            {
                $activeCurrencies = explode(',', $config->active_currencies) ;
                $where = ' WHERE currency_code IN ("'.implode('","', $activeCurrencies).'")' ;
            }
            else
            {
                $where = '' ;
            }
            $query->clear();
            $query->select('currency_code,  currency_name')
                ->from('#__jd_currencies');
            if ($where)
            {
                $query->where($where);
            }
            $db->setQuery($query) ;
            $options = array() ;
            $options[] = JHtml::_('select.option', '', JText::_('JD_SELECT_CURRENCY'), 'currency_code', 'currency_name') ;
            $options = array_merge($options, $db->loadObjectList()) ;
            $lists['currency_code'] =  JHtml::_('select.genericlist', $options, 'currency_code', ' class="input-large" ', 'currency_code', 'currency_name', $input->get('currency_code', '', 'none')) ;
        }

        $methods = os_payments::getPaymentMethods();
        $method = os_payments::getPaymentMethod($paymentMethod) ;

        $options =  array() ;
        $options[] = JHtml::_('select.option', 'Visa', 'Visa') ;
        $options[] = JHtml::_('select.option', 'MasterCard', 'MasterCard') ;
        $options[] = JHtml::_('select.option', 'Discover', 'Discover') ;
        $options[] = JHtml::_('select.option', 'Amex', 'American Express') ;
        $lists['card_type'] = JHtml::_('select.genericlist', $options, 'card_type', ' class="inputbox" ', 'value', 'text') ;
        if (DonationHelper::isPaymentMethodEnabled('os_echeck'))
        {
            $options = array() ;
            $options[] = JHtml::_('select.option', 'CHECKING', JText::_('JD_BANK_TYPE_CHECKING')) ;
            $options[] = JHtml::_('select.option', 'BUSINESSCHECKING', JText::_('JD_BANK_TYPE_BUSINESSCHECKING')) ;
            $options[] = JHtml::_('select.option', 'SAVINGS', JText::_('JD_BANK_TYPE_SAVINGS')) ;
            $lists['x_bank_acct_type'] = JHtml::_('select.genericlist', $options, 'x_bank_acct_type', ' class="inputbox" ', 'value', 'text', $input->get('x_bank_acct_type', '', 'none')) ;
        }
        //iDeal Mollie support
        $idealEnabled = DonationHelper::isPaymentMethodEnabled('os_ideal') ;
        if ($idealEnabled)
        {
            $bankLists = DonationHelper::getBankLists() ;
            $options = array() ;
            foreach ($bankLists as $bankId => $bankName)
            {
                $options[] = JHtml::_('select.option', $bankId, $bankName) ;
            }
            $lists['bank_id'] = JHtml::_('select.genericlist', $options, 'bank_id', ' class="inputbox" ', 'value', 'text', $input->getInt('bank_id', 0));
        }

        if ($campaignId > 0 && !$captchaInvalid)
        {
            $this->showCampaignSelection = false;
        }
        else
        {
            $this->showCampaignSelection = true;
        }

        //Captcha integration
        $showCaptcha = 0;
        if ($config->enable_captcha)
        {
            $captchaPlugin = JFactory::getApplication()->getParams()->get('captcha', JFactory::getConfig()->get('captcha'));
            if ($captchaPlugin)
            {
                $showCaptcha = 1;
                $this->captcha = JCaptcha::getInstance($captchaPlugin)->display('dynamic_recaptcha_1', 'dynamic_recaptcha_1', 'required');
            }
            else
            {
                JFactory::getApplication()->enqueueMessage(JText::_('JD_CAPTCHA_NOT_ACTIVATED_IN_YOUR_SITE'), 'error');
            }
        }

        $contentPlugin = $this->input->getInt('content_plugin', 0);
        if ($contentPlugin)
        {
            $donationPageUrl = base64_encode(JUri::getInstance()->toString());
        }
        else
        {
            $donationPageUrl = '';
        }
        $this->form = $form;
        //Assign these parameters
        $this->userId = $userId;
        $this->paymentMethod = $paymentMethod;
        $this->lists = $lists;
        $this->config = $config;
        $this->amount = $amount;
        $this->rdAmount = $rdAmount;
        $this->donationType = $donationType;
        $this->campaignId = $campaignId;
        $this->recurringString = $recurringString;
        $this->methods = $methods;
        $this->method = $method;
        $this->idealEnabled = $idealEnabled;
        $this->rowCampaigns = $rowCampaigns;
        $this->captchaInvalid = $captchaInvalid;
        $this->showCaptcha = $showCaptcha;
        $this->donationPageUrl = $donationPageUrl;

        parent::display();
    }
}